/* Settings.c generated by valac 0.40.6, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (https://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*/


#include <glib.h>
#include <glib-object.h>
#include <granite.h>


#define CAPTIVE_TYPE_SETTINGS (captive_settings_get_type ())
#define CAPTIVE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAPTIVE_TYPE_SETTINGS, CaptiveSettings))
#define CAPTIVE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAPTIVE_TYPE_SETTINGS, CaptiveSettingsClass))
#define CAPTIVE_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAPTIVE_TYPE_SETTINGS))
#define CAPTIVE_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAPTIVE_TYPE_SETTINGS))
#define CAPTIVE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAPTIVE_TYPE_SETTINGS, CaptiveSettingsClass))

typedef struct _CaptiveSettings CaptiveSettings;
typedef struct _CaptiveSettingsClass CaptiveSettingsClass;
typedef struct _CaptiveSettingsPrivate CaptiveSettingsPrivate;

#define CAPTIVE_SETTINGS_TYPE_WINDOW_STATE (captive_settings_window_state_get_type ())
enum  {
	CAPTIVE_SETTINGS_0_PROPERTY,
	CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY,
	CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY,
	CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY,
	CAPTIVE_SETTINGS_ENABLED_PROPERTY,
	CAPTIVE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* captive_settings_properties[CAPTIVE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CaptiveSettings {
	GraniteServicesSettings parent_instance;
	CaptiveSettingsPrivate * priv;
};

struct _CaptiveSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

typedef enum  {
	CAPTIVE_SETTINGS_WINDOW_STATE_NORMAL,
	CAPTIVE_SETTINGS_WINDOW_STATE_MAXIMIZED,
	CAPTIVE_SETTINGS_WINDOW_STATE_FULLSCREEN
} CaptiveSettingsWindowState;

struct _CaptiveSettingsPrivate {
	gint _window_width;
	gint _window_height;
	CaptiveSettingsWindowState _window_state;
	gboolean _enabled;
};


static gpointer captive_settings_parent_class = NULL;
static CaptiveSettings* captive_settings_main_settings;
static CaptiveSettings* captive_settings_main_settings = NULL;

GType captive_settings_get_type (void) G_GNUC_CONST;
GType captive_settings_window_state_get_type (void) G_GNUC_CONST;
#define CAPTIVE_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CAPTIVE_TYPE_SETTINGS, CaptiveSettingsPrivate))
CaptiveSettings* captive_settings_get_default (void);
CaptiveSettings* captive_settings_new (void);
CaptiveSettings* captive_settings_construct (GType object_type);
gint captive_settings_get_window_width (CaptiveSettings* self);
void captive_settings_set_window_width (CaptiveSettings* self,
                                        gint value);
gint captive_settings_get_window_height (CaptiveSettings* self);
void captive_settings_set_window_height (CaptiveSettings* self,
                                         gint value);
CaptiveSettingsWindowState captive_settings_get_window_state (CaptiveSettings* self);
void captive_settings_set_window_state (CaptiveSettings* self,
                                        CaptiveSettingsWindowState value);
gboolean captive_settings_get_enabled (CaptiveSettings* self);
void captive_settings_set_enabled (CaptiveSettings* self,
                                   gboolean value);
static void captive_settings_finalize (GObject * obj);
static void _vala_captive_settings_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_captive_settings_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);


GType
captive_settings_window_state_get_type (void)
{
	static volatile gsize captive_settings_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&captive_settings_window_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CAPTIVE_SETTINGS_WINDOW_STATE_NORMAL, "CAPTIVE_SETTINGS_WINDOW_STATE_NORMAL", "normal"}, {CAPTIVE_SETTINGS_WINDOW_STATE_MAXIMIZED, "CAPTIVE_SETTINGS_WINDOW_STATE_MAXIMIZED", "maximized"}, {CAPTIVE_SETTINGS_WINDOW_STATE_FULLSCREEN, "CAPTIVE_SETTINGS_WINDOW_STATE_FULLSCREEN", "fullscreen"}, {0, NULL, NULL}};
		GType captive_settings_window_state_type_id;
		captive_settings_window_state_type_id = g_enum_register_static ("CaptiveSettingsWindowState", values);
		g_once_init_leave (&captive_settings_window_state_type_id__volatile, captive_settings_window_state_type_id);
	}
	return captive_settings_window_state_type_id__volatile;
}


CaptiveSettings*
captive_settings_get_default (void)
{
	CaptiveSettings* result = NULL;
	CaptiveSettings* _tmp0_;
	CaptiveSettings* _tmp2_;
	_tmp0_ = captive_settings_main_settings;
	if (_tmp0_ == NULL) {
		CaptiveSettings* _tmp1_;
		_tmp1_ = captive_settings_new ();
		_g_object_unref0 (captive_settings_main_settings);
		captive_settings_main_settings = _tmp1_;
	}
	_tmp2_ = captive_settings_main_settings;
	result = _tmp2_;
	return result;
}


CaptiveSettings*
captive_settings_construct (GType object_type)
{
	CaptiveSettings * self = NULL;
	self = (CaptiveSettings*) granite_services_settings_construct (object_type, "io.elementary.desktop.capnet-assist");
	return self;
}


CaptiveSettings*
captive_settings_new (void)
{
	return captive_settings_construct (CAPTIVE_TYPE_SETTINGS);
}


gint
captive_settings_get_window_width (CaptiveSettings* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_width;
	result = _tmp0_;
	return result;
}


void
captive_settings_set_window_width (CaptiveSettings* self,
                                   gint value)
{
	g_return_if_fail (self != NULL);
	if (captive_settings_get_window_width (self) != value) {
		self->priv->_window_width = value;
		g_object_notify_by_pspec ((GObject *) self, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY]);
	}
}


gint
captive_settings_get_window_height (CaptiveSettings* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_height;
	result = _tmp0_;
	return result;
}


void
captive_settings_set_window_height (CaptiveSettings* self,
                                    gint value)
{
	g_return_if_fail (self != NULL);
	if (captive_settings_get_window_height (self) != value) {
		self->priv->_window_height = value;
		g_object_notify_by_pspec ((GObject *) self, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY]);
	}
}


CaptiveSettingsWindowState
captive_settings_get_window_state (CaptiveSettings* self)
{
	CaptiveSettingsWindowState result;
	CaptiveSettingsWindowState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_state;
	result = _tmp0_;
	return result;
}


void
captive_settings_set_window_state (CaptiveSettings* self,
                                   CaptiveSettingsWindowState value)
{
	g_return_if_fail (self != NULL);
	if (captive_settings_get_window_state (self) != value) {
		self->priv->_window_state = value;
		g_object_notify_by_pspec ((GObject *) self, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY]);
	}
}


gboolean
captive_settings_get_enabled (CaptiveSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled;
	result = _tmp0_;
	return result;
}


void
captive_settings_set_enabled (CaptiveSettings* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	if (captive_settings_get_enabled (self) != value) {
		self->priv->_enabled = value;
		g_object_notify_by_pspec ((GObject *) self, captive_settings_properties[CAPTIVE_SETTINGS_ENABLED_PROPERTY]);
	}
}


static void
captive_settings_class_init (CaptiveSettingsClass * klass)
{
	captive_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CaptiveSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_captive_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_captive_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = captive_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY, captive_settings_properties[CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY] = g_param_spec_enum ("window-state", "window-state", "window-state", CAPTIVE_SETTINGS_TYPE_WINDOW_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_SETTINGS_ENABLED_PROPERTY, captive_settings_properties[CAPTIVE_SETTINGS_ENABLED_PROPERTY] = g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
captive_settings_instance_init (CaptiveSettings * self)
{
	self->priv = CAPTIVE_SETTINGS_GET_PRIVATE (self);
}


static void
captive_settings_finalize (GObject * obj)
{
	CaptiveSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAPTIVE_TYPE_SETTINGS, CaptiveSettings);
	G_OBJECT_CLASS (captive_settings_parent_class)->finalize (obj);
}


GType
captive_settings_get_type (void)
{
	static volatile gsize captive_settings_type_id__volatile = 0;
	if (g_once_init_enter (&captive_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CaptiveSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) captive_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CaptiveSettings), 0, (GInstanceInitFunc) captive_settings_instance_init, NULL };
		GType captive_settings_type_id;
		captive_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "CaptiveSettings", &g_define_type_info, 0);
		g_once_init_leave (&captive_settings_type_id__volatile, captive_settings_type_id);
	}
	return captive_settings_type_id__volatile;
}


static void
_vala_captive_settings_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	CaptiveSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAPTIVE_TYPE_SETTINGS, CaptiveSettings);
	switch (property_id) {
		case CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY:
		g_value_set_int (value, captive_settings_get_window_width (self));
		break;
		case CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY:
		g_value_set_int (value, captive_settings_get_window_height (self));
		break;
		case CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY:
		g_value_set_enum (value, captive_settings_get_window_state (self));
		break;
		case CAPTIVE_SETTINGS_ENABLED_PROPERTY:
		g_value_set_boolean (value, captive_settings_get_enabled (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_captive_settings_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	CaptiveSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAPTIVE_TYPE_SETTINGS, CaptiveSettings);
	switch (property_id) {
		case CAPTIVE_SETTINGS_WINDOW_WIDTH_PROPERTY:
		captive_settings_set_window_width (self, g_value_get_int (value));
		break;
		case CAPTIVE_SETTINGS_WINDOW_HEIGHT_PROPERTY:
		captive_settings_set_window_height (self, g_value_get_int (value));
		break;
		case CAPTIVE_SETTINGS_WINDOW_STATE_PROPERTY:
		captive_settings_set_window_state (self, g_value_get_enum (value));
		break;
		case CAPTIVE_SETTINGS_ENABLED_PROPERTY:
		captive_settings_set_enabled (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



